import type { IReader, IReaderResettable } from '../../util/buffers';
import type { BinaryJsonDecoder, PackValue } from '../types';
export declare class RespDecoder<R extends IReader & IReaderResettable = IReader & IReaderResettable> implements BinaryJsonDecoder {
    reader: R;
    constructor(reader?: R);
    read(uint8: Uint8Array): PackValue;
    decode(uint8: Uint8Array): unknown;
    val(): unknown;
    readMinorLen(minor: number): number;
    protected readLength(): number;
    readBool(): boolean;
    readInt(): number;
    readFloat(): number;
    readBigint(): bigint;
    readStrSimple(): string;
    readStrVerbatim(): string | Uint8Array;
    readStrBulk(): Uint8Array;
    readErrSimple(): Error;
    readErrBulk(): Error;
    readArr(): unknown[];
    readSet(): Set<unknown>;
    readObj(): Record<string, unknown>;
}
